/******************************************************************************/
/* CORPORATIVO                                                                */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: INSERE_TRABRELPROCF                                                  */
/*                                                                            */
/* Criao:                                                                   */
/*    16/03/2007 - Welbert                                                    */
/* Descrio: Grava os dados do processo de fabricao do produto na tabela   */
/*            tmp para que o relatorio acesse estes dados.                    */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'INSERE_TRABRELPROCF'  and
            type   = 'P'                    and
            u.uid  = o.uid                  and
            u.name = USER)
DROP PROCEDURE INSERE_TRABRELPROCF
GO

CREATE PROCEDURE INSERE_TRABRELPROCF
                 @P_NRTIPOCUSTO     smallint,
                 @P_NMTIPOCUSTO     VARCHAR(50),
                 @P_CDPRODUTOINI    VARCHAR(20),
                 @P_CDPRODUTOFIN    VARCHAR(20),
                 @P_CDFILIAL        VARCHAR(04),         
                 @P_CDPROCFABRIC    VARCHAR(10),
                 @P_IDLOCAL         VARCHAR(1),
                 @P_NRORDPRODINI    VARCHAR(10),
                 @P_NRORDPRODFIN    VARCHAR(10),
                 @P_NRSUBOP         VARCHAR(1),
                 @P_DTGERORDPRODINI DATETIME,
                 @P_DTGERORDPRODFIN DATETIME,
                 @P_DTHRINICIAOPINI DATETIME,
                 @P_DTHRINICIAOPFIN DATETIME,
                 @P_SEQTRABPROCF    VARCHAR(10) OUTPUT
AS
   DECLARE @V_SEQUENCIAL   VARCHAR(20);
   DECLARE @V_INQUEBRAPAG  smallint;
   DECLARE @V_NIVEL        VARCHAR(5);
   DECLARE @V_INSEQNIVEL   smallint;
   DECLARE @V_CDARVPRODORIG    VARCHAR(20);
   DECLARE @V_NMPRODUTOORIG    VARCHAR(50);
   DECLARE @V_SGUNPORIG        VARCHAR(10);
   DECLARE @V_CDARVPROD        VARCHAR(20);
   DECLARE @V_NMPRODUTO        VARCHAR(50);
   DECLARE @V_SGUNIDADE        VARCHAR(10);
   DECLARE @V_NMPROCFABRIC     VARCHAR(50);

   DECLARE @V_INSUMO_CDPRODUTO     VARCHAR(10);
   DECLARE @V_INSUMO_CDPRODINSUMO  VARCHAR(10);
   DECLARE @V_INSUMO_CDPROCFABRIC  VARCHAR(10);
   DECLARE @V_INSUMO_IDPROFABPADR  VARCHAR(1);
   DECLARE @V_INSUMO_QUANTIDADE    DOUBLE PRECISION;

   DECLARE @V_TRAB_CDPRODORIGPF   VARCHAR(10);
   DECLARE @V_TRAB_CDPROCFABRPF   VARCHAR(10);
   DECLARE @V_TRAB_QTPADPROCPF    DOUBLE PRECISION;
   DECLARE @V_TRAB_IDQUEBRAPGPF   VARCHAR(1);
   DECLARE @V_TRAB_NRTRABRELPF    VARCHAR(10);
   DECLARE @V_TRAB_IDNIVELPF      VARCHAR(5);

   DECLARE @V_REG_CDPRODUTO       VARCHAR(10);
   DECLARE @V_REG_CDPROCFABRIC    VARCHAR(10);
   DECLARE @V_REG_IDPROFABPADR    VARCHAR(1);
   DECLARE @V_REG_QTPADPROCFAB  DOUBLE PRECISION;
/* VARIAVEIS DO CURSOR DE OP*/
   DECLARE @V_NRORDPROD     VARCHAR(10);
   DECLARE @V_NRSUBORDPROD  VARCHAR(1);
   DECLARE @V_IDSITORDPROD  VARCHAR(1);
   DECLARE @V_IDBUSCADADOP  VARCHAR(1);
   DECLARE @V_IDPRIMVEZPF   VARCHAR(1);
   DECLARE @V_INSUMO_NRLANCESTQ VARCHAR(10);
   DECLARE @V_INSUMO_NRRETEST VARCHAR(10);
   DECLARE @V_QUANTIDADE DOUBLE PRECISION;

BEGIN
   DECLARE @V_PARAMETROS VARCHAR(50);

   SET @V_PARAMETROS = 'TRABRELPROCF'+@P_CDFILIAL;
   EXEC NOVO_CODIGO @V_PARAMETROS, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
   SET @V_SEQUENCIAL = SUBSTRING(@V_SEQUENCIAL, 11,10);

   SET @V_INQUEBRAPAG = 0;

   IF @P_IDLOCAL = 'P' BEGIN
      DECLARE C_REG CURSOR FOR
         SELECT
            PF.CDPRODUTO, PF.CDPROCFABRIC, PF.IDPROFABPADR, PF.QTPADPROCFAB
         FROM
            PRODUTO PROD,
            PROCFABRICA PF
         WHERE
            (PF.CDFILIAL = @P_CDFILIAL) AND
            ((PROD.CDARVPROD BETWEEN @P_CDPRODUTOINI AND @P_CDPRODUTOFIN)OR
            ((@P_CDPRODUTOINI IS NULL) AND (@P_CDPRODUTOFIN IS NULL)))AND
            (PF.CDPRODUTO = PROD.CDPRODUTO)                    AND
            ((CHARINDEX( PF.CDPROCFABRIC, @P_CDPROCFABRIC) > 0) OR  (@P_CDPROCFABRIC IS NULL))
         ORDER BY
            PROD.CDARVPROD,
            PF.IDPROFABPADR DESC,
            PF.CDPROCFABRIC;

      OPEN C_REG;
      FETCH NEXT FROM C_REG INTO  @V_REG_CDPRODUTO, @V_REG_CDPROCFABRIC,
                                  @V_REG_IDPROFABPADR, @V_REG_QTPADPROCFAB;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_INQUEBRAPAG = @V_INQUEBRAPAG + 1;
         SET @V_NIVEL = '1';


         SELECT
            @V_CDARVPRODORIG = PORIG.CDARVPROD, @V_NMPRODUTOORIG = PORIG.NMPRODUTO,
            @V_SGUNPORIG = PORIG.SGUNIDADE, @V_CDARVPROD = PROD.CDARVPROD,
            @V_NMPRODUTO = PROD.NMPRODUTO, @V_SGUNIDADE = PROD.SGUNIDADE,
            @V_NMPROCFABRIC = T.NMPROCFABRIC
         FROM
            PRODUTO PORIG,
            PRODUTO PROD,
            TPROCFABRICA T
         WHERE
            (PROD.CDPRODUTO  = @V_REG_CDPRODUTO)    AND
            (T.CDPROCFABRIC  = @V_REG_CDPROCFABRIC) AND
            (PORIG.CDPRODUTO = @V_REG_CDPRODUTO);

         INSERT INTO TRABRELPROCF
            (NRTRABRELPF, IDQUEBRAPGPF, CDFILIALPF, CDPRODORIGPF, CDARVPORIGPF, NMPROGORIGPF, SGUNPORIGPF,
             IDNIVELPF, QTPADPROCPF, CDPRODUTOPF, CDARVPRODPF, NMPRODUTOPF, SGUNIDADEPF,
             QUANTIDADEPF, CDPROCFABRPF, NMPROCFABRPF, IDPROFABPAPF, NRTIPOCUSTPF, NMCUSTOPF,
             NRORDPRODPF, NRSUBORDPRPF, IDPOSSACABPF, IDBUSCDADOPF, IDPRIMVEZPF)
         VALUES
            (@V_SEQUENCIAL, @V_INQUEBRAPAG, @P_CDFILIAL,   @V_REG_CDPRODUTO, @V_CDARVPRODORIG,
             @V_NMPRODUTOORIG, @V_SGUNPORIG, @V_NIVEL, @V_REG_QTPADPROCFAB, @V_REG_CDPRODUTO,
             @V_CDARVPROD, @V_NMPRODUTO, @V_SGUNIDADE, @V_REG_QTPADPROCFAB, @V_REG_CDPROCFABRIC,
             @V_NMPROCFABRIC, @V_REG_IDPROFABPADR, @P_NRTIPOCUSTO, @P_NMTIPOCUSTO, '', '', 'S', '', '');

         FETCH NEXT FROM C_REG INTO  @V_REG_CDPRODUTO, @V_REG_CDPROCFABRIC,
                                     @V_REG_IDPROFABPADR, @V_REG_QTPADPROCFAB;
      END;
      CLOSE C_REG;
      DEALLOCATE C_REG;


      DECLARE C_TRAB CURSOR FOR
              SELECT CDPRODORIGPF, CDPROCFABRPF, QTPADPROCPF,
                     IDQUEBRAPGPF, NRTRABRELPF, IDNIVELPF
              FROM TRABRELPROCF
              WHERE
                 NRTRABRELPF = @V_SEQUENCIAL AND
                 IDPOSSACABPF = 'S';

      OPEN C_TRAB;
      FETCH NEXT FROM C_TRAB INTO @V_TRAB_CDPRODORIGPF, @V_TRAB_CDPROCFABRPF, @V_TRAB_QTPADPROCPF,
                                  @V_TRAB_IDQUEBRAPGPF, @V_TRAB_NRTRABRELPF, @V_TRAB_IDNIVELPF;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_INSEQNIVEL = 0;

         DECLARE C_INSUMO CURSOR FOR
                          SELECT
                              I.CDPRODUTO,
                              I.CDPRODINSUMO,
                              P.CDPROCFABRIC,
                              P.IDPROFABPADR,
                              TEKNISA.QTPREVI_MATPRIMA( @P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, @V_TRAB_QTPADPROCPF, 'S')
                           FROM
                              INSUMETAPA I,
                              PROCFABRICA P
                           WHERE
                              (I.CDFILIAL     = @P_CDFILIAL          )AND
                              (I.CDPRODUTO    = @V_TRAB_CDPRODORIGPF )AND
                              (I.CDPROCFABRIC = @V_TRAB_CDPROCFABRPF )AND
                              (I.IDSEMIACETAP = 'S')             AND
                              (P.CDFILIAL     = I.CDFILIAL)      AND
                              (I.CDPRODINSUMO = P.CDPRODUTO)     AND
                              (P.IDPROFABPADR = 'S')
                           ORDER BY
                              P.CDPRODUTO,
                              P.IDPROFABPADR DESC,
                              P.CDPROCFABRIC;

         OPEN C_INSUMO
         FETCH NEXT FROM C_INSUMO INTO  @V_INSUMO_CDPRODUTO,
                                        @V_INSUMO_CDPRODINSUMO,
                                        @V_INSUMO_CDPROCFABRIC,
                                        @V_INSUMO_IDPROFABPADR,
                                        @V_INSUMO_QUANTIDADE;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_INSEQNIVEL = @V_INSEQNIVEL + 1;

            SELECT
               @V_CDARVPRODORIG = PORIG.CDARVPROD, @V_NMPRODUTOORIG = PORIG.NMPRODUTO,
               @V_SGUNPORIG = PORIG.SGUNIDADE, @V_CDARVPROD = PROD.CDARVPROD,
               @V_NMPRODUTO = PROD.NMPRODUTO, @V_SGUNIDADE = PROD.SGUNIDADE, @V_NMPROCFABRIC = T.NMPROCFABRIC
            FROM
               PRODUTO PORIG,
               PRODUTO PROD,
               TPROCFABRICA T
            WHERE
               (PROD.CDPRODUTO  = @V_INSUMO_CDPRODINSUMO)AND
               (T.CDPROCFABRIC  = @V_INSUMO_CDPROCFABRIC) AND
               (PORIG.CDPRODUTO = @V_TRAB_CDPRODORIGPF);

            INSERT INTO TRABRELPROCF
               (NRTRABRELPF, IDQUEBRAPGPF, CDFILIALPF, CDPRODORIGPF, CDARVPORIGPF, NMPROGORIGPF, SGUNPORIGPF,
                IDNIVELPF, QTPADPROCPF, CDPRODUTOPF, CDARVPRODPF, NMPRODUTOPF, SGUNIDADEPF,
                QUANTIDADEPF, CDPROCFABRPF, NMPROCFABRPF, IDPROFABPAPF, NRTIPOCUSTPF, NMCUSTOPF,
                NRORDPRODPF, NRSUBORDPRPF, IDPOSSACABPF, IDBUSCDADOPF, IDPRIMVEZPF)
            VALUES
               (@V_TRAB_NRTRABRELPF, @V_TRAB_IDQUEBRAPGPF, @P_CDFILIAL,   @V_TRAB_CDPRODORIGPF, @V_CDARVPRODORIG,
                @V_NMPRODUTOORIG, @V_SGUNPORIG, @V_TRAB_IDNIVELPF+'.'+ CONVERT(VARCHAR, @V_INSEQNIVEL), @V_TRAB_QTPADPROCPF,
                @V_INSUMO_CDPRODINSUMO, @V_CDARVPROD, @V_NMPRODUTO, @V_SGUNIDADE, @V_INSUMO_QUANTIDADE,
                @V_INSUMO_CDPROCFABRIC, @V_NMPROCFABRIC, @V_INSUMO_IDPROFABPADR, @P_NRTIPOCUSTO, @P_NMTIPOCUSTO, '', '', 'N', '', '');

            FETCH NEXT FROM C_INSUMO INTO  @V_INSUMO_CDPRODUTO,
                                           @V_INSUMO_CDPRODINSUMO,
                                           @V_INSUMO_CDPROCFABRIC,
                                           @V_INSUMO_IDPROFABPADR,
                                           @V_INSUMO_QUANTIDADE;
         END;
         CLOSE C_INSUMO;
         DEALLOCATE C_INSUMO;
      END;

      CLOSE C_TRAB;
      DEALLOCATE C_TRAB;
   END
   ELSE BEGIN
      IF @P_IDLOCAL = 'R' BEGIN

         DECLARE C_ORD CURSOR FOR
            SELECT
               OP.NRORDPROD,
               OP.NRSUBORDPROD ,
               OP.CDPRODUTO,
               OP.CDPROCFABRIC,
               OP.IDSITORDPROD,
               OP.QTAPRODPREOP,
               P.IDPROFABPADR
            FROM
               ORDPRODUCAO OP,
               PROCFABRICA P
            WHERE
               (OP.CDFILIAL  = @P_CDFILIAL)                       AND
               ((OP.NRORDPROD BETWEEN @P_NRORDPRODINI AND @P_NRORDPRODFIN)OR((@P_NRORDPRODINI IS NULL)AND( @P_NRORDPRODFIN IS NULL)))AND
               (OP.NRSUBORDPROD = ISNULL(@P_NRSUBOP, OP.NRSUBORDPROD))AND
               ((DTGERORDPROD BETWEEN @P_DTGERORDPRODINI AND @P_DTGERORDPRODFIN)OR ((@P_DTGERORDPRODINI IS NULL)AND( @P_DTGERORDPRODFIN IS NULL)))AND
               ((DTHRINICIAOP BETWEEN @P_DTHRINICIAOPINI AND @P_DTHRINICIAOPFIN)OR ((@P_DTHRINICIAOPINI IS NULL)AND( @P_DTHRINICIAOPFIN IS NULL)))AND
               (OP.IDSITORDPROD  <> '4') AND
               (OP.CDFILIAL     = P.CDFILIAL)  AND
               (OP.CDPRODUTO    = P.CDPRODUTO) AND
               (OP.CDPROCFABRIC = P.CDPROCFABRIC)
            ORDER BY
               OP.NRORDPROD,
               OP.NRSUBORDPROD;

         OPEN C_ORD;
         FETCH NEXT FROM C_ORD INTO  @V_NRORDPROD, @V_NRSUBORDPROD, @V_REG_CDPRODUTO,
                                     @V_REG_CDPROCFABRIC, @V_IDSITORDPROD, @V_REG_QTPADPROCFAB,
                                     @V_REG_IDPROFABPADR;

         WHILE(@@FETCH_STATUS = 0)BEGIN
            SET @V_INQUEBRAPAG = @V_INQUEBRAPAG + 1;
            SET @V_NIVEL = '1';

            SELECT
               @V_CDARVPRODORIG=PORIG.CDARVPROD, @V_NMPRODUTOORIG=PORIG.NMPRODUTO,
               @V_SGUNPORIG=PORIG.SGUNIDADE, @V_CDARVPROD=PROD.CDARVPROD,
               @V_NMPRODUTO=PROD.NMPRODUTO, @V_SGUNIDADE=PROD.SGUNIDADE, @V_NMPROCFABRIC=T.NMPROCFABRIC
            FROM
               PRODUTO PORIG,
               PRODUTO PROD,
               TPROCFABRICA T
            WHERE
               (PROD.CDPRODUTO  = @V_REG_CDPRODUTO   )    AND
               (T.CDPROCFABRIC  = @V_REG_CDPROCFABRIC) AND
               (PORIG.CDPRODUTO = @V_REG_CDPRODUTO   );

            IF @V_IDSITORDPROD = '1' BEGIN
               SET @V_IDBUSCADADOP  = 'N';
            END
            ELSE
               SET @V_IDBUSCADADOP = 'S';

            INSERT INTO TRABRELPROCF
               (NRTRABRELPF, IDQUEBRAPGPF, CDFILIALPF, CDPRODORIGPF, CDARVPORIGPF, NMPROGORIGPF, SGUNPORIGPF,
                IDNIVELPF, QTPADPROCPF, CDPRODUTOPF, CDARVPRODPF, NMPRODUTOPF, SGUNIDADEPF,
                QUANTIDADEPF, CDPROCFABRPF, NMPROCFABRPF, IDPROFABPAPF, NRTIPOCUSTPF, NMCUSTOPF,
                NRORDPRODPF, NRSUBORDPRPF, IDPOSSACABPF, IDBUSCDADOPF, IDPRIMVEZPF)
            VALUES
               (@V_SEQUENCIAL, @V_INQUEBRAPAG, @P_CDFILIAL,   @V_REG_CDPRODUTO, @V_CDARVPRODORIG,
                @V_NMPRODUTOORIG, @V_SGUNPORIG, @V_NIVEL, @V_REG_QTPADPROCFAB, @V_REG_CDPRODUTO,
                @V_CDARVPROD, @V_NMPRODUTO, @V_SGUNIDADE, @V_REG_QTPADPROCFAB, @V_REG_CDPROCFABRIC,
                @V_NMPROCFABRIC, @V_REG_IDPROFABPADR, @P_NRTIPOCUSTO, @P_NMTIPOCUSTO, @V_NRORDPROD ,
                @V_NRSUBORDPROD, 'S', @V_IDBUSCADADOP, 'T');

            FETCH NEXT FROM C_ORD INTO  @V_NRORDPROD, @V_NRSUBORDPROD, @V_REG_CDPRODUTO,
                                     @V_REG_CDPROCFABRIC, @V_IDSITORDPROD, @V_REG_QTPADPROCFAB,
                                     @V_REG_IDPROFABPADR;
         END;
         CLOSE C_ORD;
         DEALLOCATE C_ORD


         DECLARE C_TRAB CURSOR FOR
                        SELECT IDQUEBRAPGPF, CDPRODORIGPF, CDPROCFABRPF,
                               IDNIVELPF, NRORDPRODPF, NRSUBORDPRPF, IDBUSCDADOPF,
                               QTPADPROCPF, NRTRABRELPF, IDPRIMVEZPF
                        FROM TRABRELPROCF
                        WHERE
                           NRTRABRELPF = @V_SEQUENCIAL AND
                           IDPOSSACABPF = 'S';
         OPEN C_TRAB;
         FETCH NEXT FROM C_TRAB INTO @V_TRAB_IDQUEBRAPGPF, @V_TRAB_CDPRODORIGPF,
                                     @V_TRAB_CDPROCFABRPF, @V_TRAB_IDNIVELPF, @V_NRORDPROD,
                                     @V_NRSUBORDPROD, @V_IDBUSCADADOP, @V_TRAB_QTPADPROCPF,
                                     @V_TRAB_NRTRABRELPF, @V_IDPRIMVEZPF;


         WHILE(@@FETCH_STATUS =0) BEGIN
            IF (@V_IDPRIMVEZPF = 'T')AND(@V_IDBUSCADADOP = 'S') BEGIN
               SET @V_INSEQNIVEL = 0;

               DECLARE C_INSUMO CURSOR FOR
                                  SELECT
                                     I.CDPRODUTO   ,
                                     I.CDPRODINSUMO,
                                     I.CDPROCFABRIC,
                                     P.IDPROFABPADR,
                                     IT.QTPRERETPROD,
                                     R.NRLANCESTQ,
                                     IT.NRRETEST
                                  FROM
                                     INSUMETAPA I, RETIRADAESTO R, ITEMRETIEST IT, PROCFABRICA P
                                  WHERE
                                     R.CDFILIAL     = @P_CDFILIAL     AND
                                     R.NRORDPROD    = @V_NRORDPROD    AND
                                     R.NRSUBORDPROD = @V_NRSUBORDPROD AND
                                     I.CDPROCFABRIC = @V_TRAB_CDPROCFABRPF AND
                                     I.CDPRODUTO    = @V_TRAB_CDPRODORIGPF AND
                                     I.IDSEMIACETAP = 'S'             AND
                                     R.CDFILIAL     = IT.CDFILIAL     AND
                                     R.NRRETEST     = IT.NRRETEST     AND
                                     R.CDETAPAPROD  = I.CDETAPAPROD   AND
                                     IT.CDPRODUTO    = I.CDPRODINSUMO  AND
                                     R.CDFILIAL     = I.CDFILIAL      AND
                                     P.CDPRODUTO    = I.CDPRODINSUMO  AND
                                     P.CDFILIAL     = I.CDFILIAL      AND
                                     P.IDPROFABPADR = 'S'
                                  ORDER BY
                                     P.CDPRODUTO,
                                     P.IDPROFABPADR DESC,
                                     P.CDPROCFABRIC;
               OPEN C_INSUMO;
               FETCH NEXT FROM C_INSUMO INTO  @V_INSUMO_CDPRODUTO,
                                        @V_INSUMO_CDPRODINSUMO,
                                        @V_INSUMO_CDPROCFABRIC,
                                        @V_INSUMO_IDPROFABPADR,
                                        @V_INSUMO_QUANTIDADE,
                                        @V_INSUMO_NRLANCESTQ,
                                        @V_INSUMO_NRRETEST;

               WHILE(@@FETCH_STATUS =0) BEGIN
                  SET @V_INSEQNIVEL = @V_INSEQNIVEL +1;

                  IF(@V_INSUMO_NRLANCESTQ IS NULL) BEGIN
                     SET @V_QUANTIDADE = @V_INSUMO_QUANTIDADE;
                  END
                  ELSE BEGIN
                     SELECT
                        @V_QUANTIDADE=SUM(L.QTRETPROD)- D.DEVOLVIDA
                     FROM
                        LOTITRETIEST L,
                        RETIRADAESTO R,
                        (SELECT SUM(QTRETPROD) AS DEVOLVIDA
                         FROM
                            LOTITRETIEST L, RETIRADAESTO R
                         WHERE
                              L.CDFILIAL = @P_CDFILIAL  AND
                              IDTPRETEST = 'D'         AND
                              R.NRRETEST = @V_INSUMO_NRRETEST AND
                              L.CDFILIAL = R.CDFILIAL  AND
                              L.NRRETEST = R.NRRETEST)D
                     WHERE
                        L.CDFILIAL = @P_CDFILIAL AND
                        IDTPRETEST = 'R'         AND
                        R.NRRETEST = @V_INSUMO_NRRETEST AND
                        L.CDFILIAL = R.CDFILIAL  AND
                        L.NRRETEST = R.NRRETEST
                     GROUP BY
                        D.DEVOLVIDA;
                  END;

                  SELECT
                      @V_CDARVPRODORIG=PORIG.CDARVPROD, @V_NMPRODUTOORIG=PORIG.NMPRODUTO,
                      @V_SGUNPORIG=PORIG.SGUNIDADE,     @V_CDARVPROD=PROD.CDARVPROD,
                      @V_NMPRODUTO=PROD.NMPRODUTO,      @V_SGUNIDADE=PROD.SGUNIDADE,
                      @V_NMPROCFABRIC=T.NMPROCFABRIC
                   FROM
                      PRODUTO PORIG,
                      PRODUTO PROD,
                      TPROCFABRICA T
                   WHERE
                      (PROD.CDPRODUTO  = @V_INSUMO_CDPRODINSUMO)AND
                      (T.CDPROCFABRIC  = @V_INSUMO_CDPROCFABRIC) AND
                      (PORIG.CDPRODUTO = @V_TRAB_CDPRODORIGPF);

                  INSERT INTO TRABRELPROCF
                      (NRTRABRELPF, IDQUEBRAPGPF, CDFILIALPF, CDPRODORIGPF, CDARVPORIGPF, NMPROGORIGPF, SGUNPORIGPF,
                       IDNIVELPF, QTPADPROCPF, CDPRODUTOPF, CDARVPRODPF, NMPRODUTOPF, SGUNIDADEPF,
                       QUANTIDADEPF, CDPROCFABRPF, NMPROCFABRPF, IDPROFABPAPF, NRTIPOCUSTPF, NMCUSTOPF,
                       NRORDPRODPF, NRSUBORDPRPF, IDPOSSACABPF, IDBUSCDADOPF, IDPRIMVEZPF)
                  VALUES
                      (@V_TRAB_NRTRABRELPF, @V_TRAB_IDQUEBRAPGPF, @P_CDFILIAL, @V_TRAB_CDPRODORIGPF, @V_CDARVPRODORIG,
                       @V_NMPRODUTOORIG, @V_SGUNPORIG, @V_TRAB_IDNIVELPF+'.'+CONVERT(VARCHAR,@V_INSEQNIVEL), @V_TRAB_QTPADPROCPF,
                       @V_INSUMO_CDPRODINSUMO, @V_CDARVPROD, @V_NMPRODUTO, @V_SGUNIDADE, @V_QUANTIDADE,
                       @V_INSUMO_CDPROCFABRIC, @V_NMPROCFABRIC, @V_INSUMO_IDPROFABPADR, @P_NRTIPOCUSTO, @P_NMTIPOCUSTO,
                       @V_NRORDPROD, @V_NRSUBORDPROD, 'N', 'N', 'F');


                  FETCH NEXT FROM C_INSUMO INTO  @V_INSUMO_CDPRODUTO,
                                        @V_INSUMO_CDPRODINSUMO,
                                        @V_INSUMO_CDPROCFABRIC,
                                        @V_INSUMO_IDPROFABPADR,
                                        @V_INSUMO_QUANTIDADE,
                                        @V_INSUMO_NRLANCESTQ,
                                        @V_INSUMO_NRRETEST;

               END;
               CLOSE C_INSUMO;
               DEALLOCATE C_INSUMO;
            END
            ELSE BEGIN
               SET @V_INSEQNIVEL = 0;
               DECLARE C_INSUMO CURSOR FOR
                                SELECT
                                   I.CDPRODUTO,
                                   I.CDPRODINSUMO,
                                   P.CDPROCFABRIC,
                                   P.IDPROFABPADR,
                                   TEKNISA.QTPREVI_MATPRIMA( @P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, @V_TRAB_QTPADPROCPF, 'S') AS QUANTIDADE
                                FROM
                                   INSUMETAPA I,
                                   PROCFABRICA P
                                WHERE
                                   (I.CDFILIAL     = @P_CDFILIAL          )AND
                                   (I.CDPRODUTO    = @V_TRAB_CDPRODORIGPF )AND
                                   (I.CDPROCFABRIC = @V_TRAB_CDPROCFABRPF )AND
                                   (I.IDSEMIACETAP = 'S')             AND
                                   (P.CDFILIAL     = I.CDFILIAL)      AND
                                   (I.CDPRODINSUMO = P.CDPRODUTO)     AND
                                   (P.IDPROFABPADR = 'S')
                                ORDER BY
                                   P.CDPRODUTO,
                                   P.IDPROFABPADR DESC,
                                   P.CDPROCFABRIC;

               OPEN C_INSUMO;
               FETCH NEXT FROM C_INSUMO INTO  @V_INSUMO_CDPRODUTO,
                                        @V_INSUMO_CDPRODINSUMO,
                                        @V_INSUMO_CDPROCFABRIC,
                                        @V_INSUMO_IDPROFABPADR,
                                        @V_INSUMO_QUANTIDADE;

               WHILE(@@FETCH_STATUS = 0) BEGIN
                  SET @V_INSEQNIVEL = @V_INSEQNIVEL + 1;

                  SELECT
                     @V_CDARVPRODORIG=PORIG.CDARVPROD, @V_NMPRODUTOORIG=PORIG.NMPRODUTO,
                     @V_SGUNPORIG=PORIG.SGUNIDADE, @V_CDARVPROD=PROD.CDARVPROD,
                     @V_NMPRODUTO=PROD.NMPRODUTO, @V_SGUNIDADE=PROD.SGUNIDADE, @V_NMPROCFABRIC=T.NMPROCFABRIC
                  FROM
                     PRODUTO PORIG,
                     PRODUTO PROD,
                     TPROCFABRICA T
                  WHERE
                     (PROD.CDPRODUTO  = @V_INSUMO_CDPRODINSUMO)AND                   
                     (T.CDPROCFABRIC  = @V_INSUMO_CDPROCFABRIC) AND
                     (PORIG.CDPRODUTO = @V_TRAB_CDPRODORIGPF);

                  INSERT INTO TRABRELPROCF
                     (NRTRABRELPF, IDQUEBRAPGPF, CDFILIALPF, CDPRODORIGPF, CDARVPORIGPF, NMPROGORIGPF, SGUNPORIGPF,
                      IDNIVELPF, QTPADPROCPF, CDPRODUTOPF, CDARVPRODPF, NMPRODUTOPF, SGUNIDADEPF,
                      QUANTIDADEPF, CDPROCFABRPF, NMPROCFABRPF, IDPROFABPAPF, NRTIPOCUSTPF, NMCUSTOPF,
                      NRORDPRODPF, NRSUBORDPRPF, IDPOSSACABPF, IDBUSCDADOPF, IDPRIMVEZPF)
                  VALUES
                     (@V_TRAB_NRTRABRELPF, @V_TRAB_IDQUEBRAPGPF, @P_CDFILIAL, @V_TRAB_CDPRODORIGPF, @V_CDARVPRODORIG,
                      @V_NMPRODUTOORIG, @V_SGUNPORIG, @V_TRAB_IDNIVELPF+'.'+ CONVERT(VARCHAR, @V_INSEQNIVEL), @V_TRAB_QTPADPROCPF,
                      @V_INSUMO_CDPRODINSUMO, @V_CDARVPROD, @V_NMPRODUTO, @V_SGUNIDADE, @V_INSUMO_QUANTIDADE,
                      @V_INSUMO_CDPROCFABRIC, @V_NMPROCFABRIC, @V_INSUMO_IDPROFABPADR, @P_NRTIPOCUSTO, @P_NMTIPOCUSTO, @V_NRORDPROD,
                      @V_NRSUBORDPROD, 'N', 'N', 'F');

               END;
               CLOSE C_INSUMO;
               DEALLOCATE C_INSUMO;
            END;
            FETCH NEXT FROM C_TRAB INTO @V_TRAB_IDQUEBRAPGPF, @V_TRAB_CDPRODORIGPF,
                                     @V_TRAB_CDPROCFABRPF, @V_TRAB_IDNIVELPF, @V_NRORDPROD,
                                     @V_NRSUBORDPROD, @V_IDBUSCADADOP, @V_TRAB_QTPADPROCPF,
                                     @V_TRAB_NRTRABRELPF, @V_IDPRIMVEZPF;
         END;
         CLOSE C_TRAB;
         DEALLOCATE C_TRAB;
      END;
   END;
   SET @P_SEQTRABPROCF = @V_SEQUENCIAL;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'INSERE_TRABRELPROCF','4.11.215';
GO 
