var Ped05700_importacao_Solicitacao_Compras_Controller = function (ScreenService, General, templateManager, restEngine, localStorageEngine, Ped05700_importacao_Solicitacao_Compras_Service, Endereco, ZhFilterPreferences, ZHPromise, Ger01100_Transportadora_Service) {
    
    this.checkedRows   = [];
    
    this.openFilter = function(widget){
            var promises = [];
            promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
            promises.push(ZhFilterPreferences.openFilterWidget(widget));
            ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.controlaVisibilidadeImportar = function (widget){
    	var checkedRows = widget.getCheckedRows();
        
    	if(checkedRows.length > 0){
    		widget.getAction('importarSolicitacoes').isVisible = true;
    	}else{
    		widget.getAction('importarSolicitacoes').isVisible = false;
    	}
    };
    
    this.controlaImportacao = function (widget){
        var row = widget.selectedRow;
        if(row.IDMARCADO == 'S'){
            ScreenService.showMessage('Solicitação já importada!');
            row.__isSelected = false;
        }
    };
    
    this.controlaDataSource = function (widget){
        
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": 'FILIAL_LOGADA'
                }
            ];
            
        General.callRestEngine('ped#/crud/paramimppedido', 'FilterData', filter).then(function(callback){
            var row = callback.dataset.paramimppedido[0];
            if(row){
                if(row.IDIMPSCDTENTR == 'S'){
                    widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos_data";
                    widget.getField('DTPROGENTR').isVisible = true;
                    widget.reload();
                }else{
                    widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos";
                    widget.getField('DTPROGENTR').isVisible = false;
                    widget.reload();
                }
            }
            
        });
        
    };
 
    this.setFilter = function(widget){
    	// fazer os campos do filtro iniciarem como falado
    	// todos começam com T
        templateManager.container.getActiveWidget().getField('IDCDFILIAL').value('T');
        templateManager.container.getActiveWidget().getField('IDNRSOLICMP').value('T');
        templateManager.container.getActiveWidget().getField('SUBGRUPFIL').value('T');
        templateManager.container.getActiveWidget().getField('IDPRODUTO').value('T');
    	
    	// data começa com data atual
    };

    this.importaSolicitacao = function (widget){
    	var checkedRows = widget.getCheckedRows();

    // 	widget.getCheckedRows().forEach(function(row){
    //         Ped05700_importacao_Solicitacao_Compras_Service.importarSolicitacoes(row).then(function(response){
    //                 ScreenService.showMessage(response.dataset.importacaoSolicitacoes);
    //         });
    //     }.bind(this));
        var CDFILIAL;
        var TCDFILIAL;
        var CDGRUPPROD;
        var TCDGRUPPROD;
        var CDFATORPRECO;
         
        if(widget.appliedFilter.FILTER_ROW.IDCDFILIAL == 'T'){
            CDFILIAL = '';
            TCDFILIAL = 'T';
        }else{
            CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
            TCDFILIAL = '';
        }
    
        if(widget.appliedFilter.FILTER_ROW.SUBGRUPFIL == 'T'){
            CDGRUPPROD = '';
            TCDGRUPPROD = 'T';
        }else{
            CDGRUPPROD = widget.appliedFilter.FILTER_ROW.CDGRUPPROD;
            TCDGRUPPROD = 'T';
        }
        
        if(widget.appliedFilter.FILTER_ROW.NMFATORPRECO != ''){
            CDFATORPRECO = widget.appliedFilter.FILTER_ROW.CDFATORPRECO;
        }else{
            CDFATORPRECO = '';
        }
        
        function setValue(row){
            row.CDGRUPPROD = CDGRUPPROD;
            row.CDFILIAL = CDFILIAL;
            row.TCDGRUPPROD = TCDGRUPPROD;
            row.TCDFILIAL = TCDFILIAL;
            row.CDFATORPRECO = CDFATORPRECO;
        }

        checkedRows.forEach(setValue);
        
        Ped05700_importacao_Solicitacao_Compras_Service.importarSolicitacoes(checkedRows).then(function(callback){
            var widgetRetornoImportacao = templateManager.container.getWidget('popUpRetornoImportacaoSolicitacoes');
            var widget = templateManager.container.getWidget('gridSolicitaCompra');
            var retorno;
            if(callback.dataset){
                 retorno = callback.dataset.retorno;
            }else{
                 retorno = 'importado';
                
            }
            
            if(retorno != 'importado'){
                widgetRetornoImportacao.dataSource.data = retorno;
                ScreenService.openPopup(widgetRetornoImportacao).then(function(){
                    widgetRetornoImportacao.reload();
                });
            }else{
                widget.unSelectAll();
                widget.reload();
            }
            
        });
    };
   
    this.newImportacao = function(widget){
		General.newRow(widget);
	};
    
    this.filtroFilial = function(args) {
        var filialOrigem = args.owner.field.widget.currentRow.IDCDFILIAL;
        var CDFILSOLI = args.owner.field.widget.getField('NMFILIAL');

        if (filialOrigem == 'T') {
            
            CDFILSOLI.readOnly = true;
        } else if (filialOrigem == 'L') {
            
            CDFILSOLI.readOnly = false;
        }
        CDFILSOLI.value('');  
        
    };

    this.filtroNrSolicitacao = function(args) {
        var NrSolicitacao = args.owner.field.widget.currentRow.IDNRSOLICMP;
        var NRSOLICMP = args.owner.field.widget.getField('NRSOLICMP');

        if (NrSolicitacao == 'T') {
            
            NRSOLICMP.readOnly = true;
        } else if (NrSolicitacao == 'L') {
            
            NRSOLICMP.readOnly = false;
        }
        NRSOLICMP.value('');
    };
    
    this.filtroProdutoLista = function() {
        var widget = templateManager.container.getActiveWidget();
        var produtos = widget.currentRow.IDPRODUTO;
        var NMPRODUTOINI = widget.getField('NMPRODUTOINI');
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');

        if (produtos == 'T') {
            NMPRODUTOINI.readOnly = true;
            NMPRODUTOFIN.readOnly = true;
            NMPRODUTOFIN.validations = {};
            NMPRODUTOINI.validations = {};
        } else if (produtos == 'L') {
            NMPRODUTOINI.readOnly = false;
            NMPRODUTOFIN.validations.required = true;
            NMPRODUTOINI.validations.required = true;
        }
        NMPRODUTOINI.value('');
        NMPRODUTOFIN.value('');
        widget.currentRow.NMPRODUTOFIN = "";
        widget.currentRow.NMPRODUTOINI = "";
        widget.reload();

    };
    
    this.filtroProdutoInicial = function() {
        var widget = templateManager.container.getActiveWidget();
        var row = widget.currentRow;
        var produtoInicial = row.CDPRODUTOINI;
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');

        if(produtoInicial == undefined || produtoInicial == ''){
            NMPRODUTOFIN.readOnly = true;
            widget.currentRow.NMPRODUTOFIN = "";
            NMPRODUTOFIN.value('');
            widget.reload();
        }else{
            NMPRODUTOFIN.readOnly = false;
        }
        
    };
    
    this.filtroProdutoFinal = function() {
        var widget = templateManager.container.getActiveWidget();
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');
        var produtoInicial = widget.currentRow.CDPRODUTOINI;
        var produtoFinal = widget.currentRow.CDPRODUTOFIN;

        if(produtoInicial > produtoFinal){
            ScreenService.showMessage('Produto Final deve ser maior que o produto inicial!');
            NMPRODUTOFIN.setValue('');
        }
                    
        
    };
    
    this.filtroSubGrup = function(args) {
        var SubGrup = args.owner.field.widget.currentRow.SUBGRUPFIL;
        var CDGRUPPROD = args.owner.field.widget.getField('CDGRUPPROD');

        if (SubGrup == 'T') {
            
            CDGRUPPROD.readOnly = true;
        } else if (SubGrup == 'L') {
            
            CDGRUPPROD.readOnly = false;
        }
        CDGRUPPROD.value('');
    };
    
    this.filtroData = function(args) {
        var setData = templateManager.container.getActiveWidget().currentRow;
        var dataSourceFilter = [
            {
                "name": "DTSOLCMP",
                "operator": "=",
                "value": setData.DTSOLCMP.start
            },
            {
                "name": "DTSOLCMP",
                "operator": "=",
                "value": setData.DTSOLCMP.end
            },
            {
                "name": "DTPROGENTR",
                "operator": "=",
                "value": setData.DTPROGENTR.start
            },
            {
                "name": "DTPROGENTR",
                "operator": "=",
                "value": setData.DTPROGENTR.end
            }
        ];
    };

    this.setDataSourceFilter = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter = [];
            
            /* CAMPO DE FILIAL NO DATASOURCEFILTER */
            var filiais = '';
            var nrSol = '';
            var subGrupo = '';
            
            if(rowPopup.IDCDFILIAL == 'T'){
                dataSourceFilter.push({
                        "name": 'P_TCDFILIAL',
                        "operator": "=",
                        "value": 'T'
                });
            }else{
                rowPopup.CDFILIAL.forEach(function(filial){
                    filiais += "_" + filial;
                });
                filiais = filiais + "_";
                
                dataSourceFilter.push({
                    "name": 'P_CDFILIAL',
                    "operator": "=",
                    "value": filiais
                });
            }
           
            /* CAMPO DE NRSOLICITAÇÃO NO DATASOURCEFILTER */
            if(rowPopup.IDNRSOLICMP == 'T'){
                dataSourceFilter.push({
                        "name": 'P_TNRSOLI',
                        "operator": "=",
                        "value": 'T'
                });
            }else{
                rowPopup.NRSOLICMP.forEach(function(nrSoli){
                    nrSol += "_" + nrSoli + rowPopup.CDFILISOLICMP;
                });
                nrSol = nrSol + "_";
                
                dataSourceFilter.push({
                    "name": 'P_NRSOLICMP',
                    "operator": "=",
                    "value": nrSol
                });
            }
             
            /* CAMPO DE SUBGRUPO NO DATASOURCEFILTER */
            // if(rowPopup.SUBGRUPFIL == 'T'){
            //     dataSourceFilter.push({
            //             "name": 'P_TCDFILIAL',
            //             "operator": "=",
            //             "value": 'T'
            //     });
            // }else{
            //     rowPopup.CDGRUPPROD.forEach(function(subGrup){
            //         subGrupo += "_" + subGrup;
            //     });
            //     subGrupo = subGrupo + "_";
                
            //     dataSourceFilter.push({
            //         "name": 'P_TCDFILIAL',
            //         "operator": "=",
            //         "value": subGrupo
            //     }); 
            // }
            
            /* CAMPO DE DATA DE SOLICITAÇÃO NO DATASOURCEFILTER */
            dataSourceFilter.push(
                {
                    "name": 'P_DTDESOLI',
                    "operator": "=",
                    "value": rowPopup.DTSOLCMP.start
                },
                {
                    "name": 'P_DTATESOLI',
                    "operator": "=",
                    "value": rowPopup.DTSOLCMP.end
                },
                {
                    "name": 'P_DTINIENT',
                    "operator": "=",
                    "value": rowPopup.DTPROGENTR.start
                },
                {
                    "name": 'P_DTFINENT',
                    "operator": "=",
                    "value": rowPopup.DTPROGENTR.end
                }
            );
            
            if(rowPopup.CDPRODUTOINI == null || rowPopup.CDPRODUTOFIN == null){
                dataSourceFilter.push({
                    "name": 'P_TPRODUTO',
                    "operator": "=",
                    "value": 'T'
                });
            }else{
                dataSourceFilter.push(
                    {
                        "name": 'PRODINI',
                        "operator": "=",
                        "value": rowPopup.CDPRODUTOINI
                    },
                    {
                        "name": 'PRODFIM',
                        "operator": "=",
                        "value": rowPopup.CDPRODUTOFIN
                    }
                );   
            }
            
            args.owner.dataSourceFilter = dataSourceFilter;
            args.owner.container.getWidget('gridSolicitaCompra').reload();
        }
    };

    
};
    
    Configuration(function (ContextRegister) {
	ContextRegister.register('Ped05700_importacao_Solicitacao_Compras_Controller', Ped05700_importacao_Solicitacao_Compras_Controller);
});